//input.cpp
#include "input.h"


KEYBOARD	Keyboard;		
MOUSE		Mouse;			//MOUSE INFO STRUCTURE
JOYSTICK	Joystick;

bool KEY_DOWN(int key)		//Global function to acces keyboard class
{					// (the old macro did not work with the debouncing code)
	return Keyboard.KeyDown(key);
}

bool MOUSE_DOWN(uint32 button)
{	if(Mouse.Button == button) return true;
	else return false; 
}

KEYBOARD::KEYBOARD()
{
	Init();					//Initialize Debounce array
}

void KEYBOARD::Update()
{
	get_key_info(&KeyBuffer);
}
int KEYBOARD::KeyDown(int key)
{
	return KeyBuffer.key_states[key >> 3] & (1 << (7 - (key % 8)));
}

/*uint*/bool KEYBOARD::Check(uint key)
{
	if(states[key])
		return 1;
	else
		return 0;
	
//	return states[key];
}

void KEYBOARD::MakeDown(uint key)
{

	states[key] = 1;

}

void KEYBOARD::MakeUp(uint key)
{

	states[key] = 0;
	
}

void KEYBOARD::Init()
{
	//Clear key_states		//128
	for(int index=0;index < 127;index++)
		states[index] = 0;
}


void MOUSE::Update()
{
	BRect	frame;

	handler->Lock();	//Must lock and unlock to use this function
													//true = queued

	handler->ChildAt(0)->GetMouse(&WinPos,&Button,true);
	
	frame =	handler->Frame();
	ScreenPos.x = WinPos.x + frame.left;
	ScreenPos.y = WinPos.y + frame.top;
	
	handler->Unlock();	

}

JOYSTICK::JOYSTICK()
{
	char 	buffer[B_OS_NAME_LENGTH];
	
	NumDevices = JoyStick.CountDevices();
	JoyStick.GetDeviceName(0,buffer);		//Get name of 1st device
	JoyStick.Open(buffer);					//Opens the joystick
	JoyStick.Update();						//Gets joystick ready
	
	NumSticks  = JoyStick.CountSticks();
	NumAxes	   = JoyStick.CountAxes();
	NumButtons = JoyStick.CountButtons();
	NumHats	   = JoyStick.CountHats();

	AxesStates = (int16 *) malloc(sizeof(int16) * JoyStick.CountAxes());
	HatStates = (uint8 *) malloc(sizeof(uint8) * JoyStick.CountAxes());
}


void JOYSTICK::Update()
{
	JoyStick.Update();
	JoyStick.GetAxisValues(AxesStates);
	ButtonStates = JoyStick.ButtonValues();
	JoyStick.GetHatValues(HatStates);
	
	//Map joystick to current window/screen size
	XPosition = 0;//(int16)((AxesStates[D_JOY_AXIS_X] + 32768) * ((float)states.HorRes/65535));
	YPosition = 0;//(int16)((AxesStates[D_JOY_AXIS_Y] + 32768) * ((float)states.VerRes/65535));

}
